<?php

$PID_NHS = "NHS-DEMO-6.0.6";      // Help/About screen and all connections to web site!
$PID     = "AB6-DEMO-6.0.6";      


$strids = array();

class abins_class {
  var $ln = 1033;
  var $cp = 1252;
  var $co = "Ability Plus Software";
  var $title = "Ability Office 6";
  var $output = "ability6.wxs";
  var $srcfld = "abbin";
  var $targetfld = null;
  var $targetID = "";
  var $helpfld = "datafiles\\help";
  var $diskID = "";
  var $licrtf = "datafiles\\Lang\\EN\\License.rtf";
  var $inifiles = "Ability6";
  var $prodstr = null;
  var $exes = null;
  var $corel = false;
  var $majver = 6;
  var $minver = 0;
  var $build = 4;
  var $menu;
  var $dir;
  var $PID;

  function abins_class() {
    $this->menu = $this->title;
    $this->dir = $this->title;
    $this->setProdstr();
    $this->setExeNames();
    $this->PID = $GLOBALS["PID"];
  }

  function setup ($co, $title, $ln, $cp) {
    $this->co = $co;
    $this->title= $title;
    $this->ln = $ln;
    $this->cp = $cp;
    $this->menu = $title;
    $this->dir = $title;
  }

  function setSrcFld($fld) {
    $this->srcfld = $fld;
  }

  function setTargetFld($fld) {
    $this->targetfld = $fld;
    $this->targetID = str2fldid($fld);
  }

  function setTargetID($fld) {
    $this->targetID = $fld;
  }

  function setProdstr() {
    if ($this->corel) {
      $this->prodstr["Write"] = "Corel Write";
      $this->prodstr["Spread"] = "Corel Calculate";
      $this->prodstr["Pres"] = "Corel Show";
    }
    else {
      $this->prodstr["Write"] = "Ability Write";
      $this->prodstr["Spread"] = "Ability Spreadsheet";
      $this->prodstr["Pres"] = "Ability Presentation";
    }
    $this->prodstr["Data"] = "Ability Database";
    $this->prodstr["Paint"] = "Ability Photopaint";
    $this->prodstr["Photo"] = "Ability Photoalbum";
  }

  function setExeNames() {
    $this->exes["Write"] = "abwrite.exe";
    $this->exes["Spread"] = "abspread.exe";
    $this->exes["Pres"] = "abpresent.exe";
    $this->exes["Data"] = "Abdata.exe";
    $this->exes["Paint"] = "abpaint.exe";
    $this->exes["Photo"] = "ABPhoto.exe";
  }

  function getver() {
    return sprintf("%d.%d.%d", $this->majver, $this->minver, $this->build);
  }

  function minVer() {
    return sprintf("%d.0.0", $this->majver);
  }

  function getProdstr($s) {
    return $this->prodstr[$s];
  }

  function getExeName($s) {
    return $this->exes[$s];
  }


  function setcorel() {
    $this->setup("Corel", "Corel Office", 1033, 1252);
    $this->output = "coreloffice2.wxs";
    $this->corel = true;
    $this->setProdstr();
    $this->licrtf = "COlic.rtf";
    $this->majver = 2;
    $this->minver = 0;
    $this->build = 0;
  }


  function setNHS() {
    $this->setup("NHS", "NHS Office", 1033, 1252);
    $this->output = "nhsoffice.wxs";
//    $this->licrtf = "COlic.rtf";
    $this->majver = 6;
    $this->minver = 0;
    $this->build = 2;
    $this->altbin = "NHS";
    $this->prodstr["Write"] = "NHS Office Write";
    $this->prodstr["Spread"] = "NHS Office Spreadsheet";
    $this->prodstr["Pres"] = "NHS Office Presentation";
    $this->helpfld = "NHS\\help";
    $this->PID = $GLOBALS["PID_NHS"];
  }
}

class abfiles_class {
  var $name;
  var $id;
  var $srcfld;
  var $targetfld;
  var $targetID;
  var $guid;
  var $diskID;
  var $altbin = null;

  function abfiles_class($name, $srcfld, $targetfld, $targetID, $diskID) {
    $this->name = $name;
    $this->id = $this->str2id($name);
    $this->srcfld = $srcfld;
    $this->targetfld= $targetfld;
    $this->targetID = $targetID;
    $this->diskID = $diskID;
    $this->guid = get_guid();
  }

  function getID() {
    return $this->id;
  }

  function getGUID() {
    return $this->guid;
  }
  
  function getCompStr() {
    return sprintf("          <Component Id='%s' Guid='%s'>\n", $this->id, $this->guid);
  }

  function getFileStr() {
    $disk = "";
    if (!empty($this->diskID))
      $disk = "DiskId='" . $this->diskID . "'";
    return sprintf("            <File Id='%s' Source='%s\%s' KeyPath='yes' Checksum='yes' %s", $this->id, $this->srcfld, $this->name, $disk);
  }

  static function cmp_obj($a, $b) {
    return strcmp($a->targetID, $b->targetID);
  }

  function str2id($s) {
  global $strids;
    $i = strpos($s, ".");
    $s[$i+1] = strtoupper($s[$i+1]);
    $srch = array (" ", ".", "/", "\\");
    $repl = array ("_", "", "_", "_");
    $s = str_replace($srch, $repl, $s);
  
    if (array_key_exists($s, $strids)) {
      $strids[$s]++;
      $s .= sprintf("_%d_", $strids[$s]);
    }
    else
      $strids[$s] = 0; 

    return $s . "ID";
  }
}



?>